﻿using System;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Cascading_ListBox_Entity_MVC.Models;

namespace Cascading_ListBox_Entity_MVC.Controllers
{
    public class HomeController : Controller
    {
        // GET: Home
        public ActionResult Index()
        {
            Cascading_ddlEntities entities = new Cascading_ddlEntities();
            CascadingModel model = new CascadingModel();
            foreach (var country in entities.Countries)
            {
                model.Countries.Add(new SelectListItem { Text = country.CountryName, Value = country.CountryId.ToString() });
            }
            return View(model);
        }

        [HttpPost]
        public ActionResult Index(int? countryId, int? stateId, int? cityId)
        {
            CascadingModel model = new CascadingModel();
            Cascading_ddlEntities entities = new Cascading_ddlEntities();
            foreach (var country in entities.Countries)
            {
                model.Countries.Add(new SelectListItem { Text = country.CountryName, Value = country.CountryId.ToString() });
            }

            if (countryId.HasValue)
            {
                var states = (from state in entities.States
                              where state.CountryId == countryId.Value
                              select state).ToList();
                foreach (var state in states)
                {
                    model.States.Add(new SelectListItem { Text = state.StateName, Value = state.StateId.ToString() });
                }

                if (stateId.HasValue)
                {
                    var cities = (from city in entities.Cities
                                  where city.StateId == stateId.Value
                                  select city).ToList();
                    foreach (var city in cities)
                    {
                        model.Cities.Add(new SelectListItem { Text = city.CityName, Value = city.CityId.ToString() });
                    }
                }
            }

            return View(model);
        }
    }
}